;###########################################################################
; mIRC Tetris v1.0 Beta
; By: Talon
;
; Controls:
;   Left Arrow:     Move Piece Left
;   Up Arrow:       Rotate Piece (if possible)
;   Right Arrow:    Move Piece Right
;   Down Arrow:     Instantly Drop Piece
;   Spacebar:       Pause the Game
;    
;###########################################################################
; Aliases
;###########################################################################

alias tetris {
  var %tw = $calc(20*10) , %th = $calc(20*20)
  if (!$window(@Tetris)) || (!$1 && $hget(Tetris,Over)) { 
    hfree -w Tetris
    window -dfpa @Tetris -1 -1 $calc(20*20) %th 
    ;window -dfpa @Tetris -1 -1 377 486 
    window -hfp @Tetris.Blocks -1 -1 $pic($qt($scriptdirblocks.png)).width $pic($qt($scriptdirblocks.png)).height

    drawpic @Tetris.Blocks 0 0 $qt($scriptdirblocks.png)

    hadd -m Tetris BlockWidth $pic($qt($scriptdirblocks.png)).width
    hadd -m Tetris BlockHeight $pic($qt($scriptdirblocks.png)).height

    var %x = 0
    while (%x < 10) {
      inc %x
      var %y = 0
      while (%y < 20) {
        inc %y
        hadd -m Tetris $+(Field-,%x,.,%y) -1
      }
    }

    hadd -m Tetris Over 0
    hadd -m Tetris Score 0
    hadd -m Tetris Time $ctime
    hadd -m Tetris Level 1
    hadd -m Tetris Lines 0
    var %Piece1 = $r(0,6) , %Piece2 = $r(0,6) , %Dir1 = $r(1,4) , %Dir2 = $r(1,4)
    hadd -m Tetris Piece %Piece1
    hadd -m Tetris Dir %Dir1
    hadd -m Tetris Next %Piece2
    hadd -m Tetris NextDir %Dir2
    hadd -m Tetris CX 4 
    hadd -m Tetris CY $Tetris.Collisiontest(%Piece1,%Dir1,4)
    hadd -m Tetris X 4
    hadd -m Tetris Y -4
  }

  drawrect -nf @Tetris 1 0 0 0 $calc(%tw *2) %th
  drawline -n @Tetris 0 1 %tw 0 %tw %th
  Tetris.TestRows
  var %x = 0
  while (%x < 10) {
    inc %x
    var %y = 0
    while (%y < 20) {
      inc %y
      var %block = $hget(Tetris,$+(Field-,%x,.,%y))
      if (%block > -1) { drawcopy -n @Tetris.Blocks $calc(%block *20) 0 20 20 @Tetris $calc((%x -1) *20) $calc((%y -1) *20) }
    }
  }

  var %col = 20 * 11 , %line = 0 , %secs = $calc($ctime - $hget(Tetris,Time))
  if (%secs >= 1500) { hadd -m Tetris Level 10 | hadd -m Tetris FallSpeed 50 }
  else if (%secs >= 1200) { hadd -m Tetris Level 9 | hadd -m Tetris FallSpeed 100 }
  else if (%secs >= 960) { hadd -m Tetris Level 8  | hadd -m Tetris FallSpeed 200 }
  else if (%secs >= 720) { hadd -m Tetris Level 7 | hadd -m Tetris FallSpeed 300 }
  else if (%secs >= 540) { hadd -m Tetris Level 6 | hadd -m Tetris FallSpeed 400 }
  else if (%secs >= 360) { hadd -m Tetris Level 5 | hadd -m Tetris FallSpeed 500 }
  else if (%secs >= 240) { hadd -m Tetris Level 4 | hadd -m Tetris FallSpeed 600 }
  else if (%secs >= 120) { hadd -m Tetris Level 3 | hadd -m Tetris FallSpeed 700 }
  else if (%secs >= 60) { hadd -m Tetris Level 2 | hadd -m Tetris FallSpeed 800 }
  else { hadd -m Tetris Level 1 | hadd -m Tetris FallSpeed 900 }
  drawtext -n @Tetris 0 %col %line Score:
  inc %line 20
  drawtext -n @Tetris 0 %col %line $base($hget(Tetris,Score),10,10,6)
  inc %line 20
  drawtext -n @Tetris 0 %col %line Time:
  inc %line 20
  drawtext -n @Tetris 0 %col %line $duration(%secs,3)
  inc %line 20
  drawtext -n @Tetris 0 %col %line Level:
  inc %line 20
  drawtext -n @Tetris 0 %col %line $hget(Tetris,Level)
  inc %line 20
  drawtext -n @Tetris 0 %col %line Lines:
  inc %line 20
  drawtext -n @Tetris 0 %col %line $hget(Tetris,Lines)
  inc %line 20  
  drawtext -n @Tetris 0 %col %line Next Piece:
  tetris.drawpiece $hget(Tetris,Next) $hget(Tetris,NextDir) 11 9
  inc %line 120   
  drawtext -n @Tetris 0 %col %line Held Piece:
  if ($hget(Tetris,Hold) != $null) { tetris.drawpiece $v1 $hget(Tetris,HoldDir) 11 15 }
  if (!$hget(Tetris,Over)) { tetris.drawpiece $hget(Tetris,Piece) $hget(Tetris,Dir) $hget(Tetris,CX) $hget(Tetris,CY) 1 }
  tetris.drawpiece $hget(Tetris,Piece) $hget(Tetris,Dir) $hget(Tetris,X) $hget(Tetris,Y)
  drawdot @Tetris
  if (!$timer(tetris) || $hget(Tetris,FallSpeed) < $timer(Tetris).delay) && (!$hget(Tetris,Over)) { .timerTetris -m 0 $hget(Tetris,FallSpeed) Tetris.HeartBeat }
}

;###########################################################################
; Tetris Specific Aliases
;###########################################################################

alias -l Tetris.HeartBeat {
  if ($hget(Tetris,Pause)) { return }
  if (!$timer(tetris)) || ($hget(Tetris,Over)) { 
    .timerTetris off 
    if ($input(Would You like to play again?,ys,@Tetris,Game Over!)) { tetris }
    else { Tetris.Terminate | return }
  }
  var %Piece = $hget(Tetris,Piece) , %Dir = $hget(Tetris,Dir) , %CX = $hget(Tetris,CX) , %CY = $hget(Tetris,CY) , %x = $hget(Tetris,x) , %y = $hget(Tetris,y)
  inc %y
  if ($Tetris.Collisiontest(%Piece,%Dir,%x,%y)) {
    dec %y
    Tetris.SetPiece %Piece %Dir %x %y
    hadd -m Tetris Piece $hget(Tetris,Next)
    hadd -m Tetris Dir $hget(Tetris,NextDir)
    hadd -m Tetris Next $r(0,6)
    hadd -m Tetris NextDir $r(1,4)
    hadd -m Tetris X 4
    hadd -m Tetris Y -4
    hadd -m Tetris CX 4
    hadd -m Tetris CY $Tetris.CollisionTest($hget(Tetris,Piece),$hget(Tetris,Dir),4)
  }
  else { hadd -m Tetris Y %y }
  tetris 1
}
alias -l Tetris.Piece {
  if ($1 = 0) { return 0.0,1.0,0.1,1.1;0.0,1.0,0.1,1.1;0.0,1.0,0.1,1.1;0.0,1.0,0.1,1.1 }
  else if ($1 = 1) { return 0.0,1.0,1.1,2.1;1.0,0.1,1.1,0.2;0.0,1.0,1.1,2.1;1.0,0.1,1.1,0.2 }
  else if ($1 = 2) { return 1.0,2.0,0.1,1.1;0.0,0.1,1.1,1.2;1.0,2.0,0.1,1.1;0.0,0.1,1.1,1.2 }
  else if ($1 = 3) { return 0.0,0.1,0.2,0.3;0.0,1.0,2.0,3.0;0.0,0.1,0.2,0.3;0.0,1.0,2.0,3.0 }
  else if ($1 = 4) { return 0.0,0.1,1.1,2.1;0.0,1.0,0.1,0.2;0.0,1.0,2.0,2.1;1.0,1.1,0.2,1.2 }
  else if ($1 = 5) { return 2.0,0.1,1.1,2.1;0.0,0.1,0.2,1.2;0.0,1.0,2.0,0.1;0.0,1.0,1.1,1.2 }
  else if ($1 = 6) { return 1.0,0.1,1.1,1.2;1.0,0.1,1.1,2.1;0.0,0.1,1.1,0.2;0.0,1.0,2.0,1.1 }
}
alias Tetris.DrawPiece {
  var %piece = $gettok($Tetris.Piece($1),$2,59)
  var %x = 0
  while (%x < $numtok(%piece,44)) {
    inc %x
    var %tp = $gettok(%piece,%x,44) , %xp = $gettok(%tp,1,46) , %yp = $gettok(%tp,2,46)
    drawcopy -n @Tetris.Blocks $calc($1 *20) $iif($5,20,0) 20 20 @Tetris $calc(($3 + %xp) *20) $calc(($4 + %yp) *20)
  }
}
alias -l Tetris.SetPiece {
  if ($4 <= 0) { hadd -m Tetris Over 1 }
  ;piece dir x y
  var %piece = $gettok($Tetris.Piece($1),$2,59)
  var %x = 0
  while (%x < $numtok(%piece,44)) {
    inc %x
    var %tp = $gettok(%piece,%x,44) , %xp = $gettok(%tp,1,46) , %yp = $gettok(%tp,2,46)
    hadd -m Tetris $+(Field-,$calc($3 + %xp + 1),.,$calc($4 + %yp + 1)) $1
  }
}
alias -l Tetris.CollisionTest {
  ;piece dir x y
  var %piece = $gettok($Tetris.Piece($1),$2,59)
  if ($4 = $null) {
    var %y = 0
    while (%y < 20) {
      inc %y
      var %x = 0
      while (%x < $numtok(%piece,44)) {
        inc %x
        var %tp = $gettok(%piece,%x,44) , %xp = $gettok(%tp,1,46) , %yp = $gettok(%tp,2,46)
        var %ax = $calc($3 + %xp + 1) , %ay = $calc(%y + %yp +1)
        if ($hget(Tetris,$+(Field-,%ax,.,%ay)) > -1 || %ay > 20) { return $calc(%y -1) }
      }
    }
  }
  else {
    var %x = 0
    while (%x < $numtok(%piece,44)) {
      inc %x
      var %tp = $gettok(%piece,%x,44) , %xp = $gettok(%tp,1,46) , %yp = $gettok(%tp,2,46)
      var %ax = $calc($3 + %xp + 1) , %ay = $calc($4 + %yp + 1)
      if ((%ay >= 0 && $hget(Tetris,$+(Field-,%ax,.,%ay)) > -1) || %ay > 20 || %ax > 10) { return $true }
    }
    return $false
  }
}
alias -l Tetris.TestRows {
  var %y = 0 , %combo = 0
  while (%y < 20) {
    inc %y
    if (!$istok($regsubex($str(.,9),//g,$hget(Tetris,$+(Field-,\n,.,%y))),-1,46)) { 
      Tetris.RemoveRow %y
      inc %combo
    }
  }
  if (%combo) { hinc Tetris Score $calc($gettok(50.125.300.800,%Combo,46) * $hget(Tetris,Level)) }
}
alias -l Tetris.RemoveRow {
  hinc Tetris Lines
  var %y = $1
  while (%y > 0) {
    var %x = 0
    while (%x < 10) {
      inc %x
      if (%y > 1) hadd -m Tetris $+(Field-,%x,.,%y) $hget(Tetris,$+(Field-,%x,.,$calc(%y -1)))
      else hadd -m Tetris $+(Field-,%x,.,%y) -1
    }
    dec %y
  }
  hadd -m Tetris CY $Tetris.CollisionTest($hget(Tetris,Piece),$hget(Tetris,Dir),$hget(Tetris,X))
}
alias Tetris.Terminate { hfree -w Tetris | .timerTetris off | window -c @Tetris | window -c @Tetris.Blocks }

;###########################################################################
; Remotes
;###########################################################################

on *:LOAD: { echo -m mIRC Tetris v1.0 Beta sucsessfully loaded! Type /tetris to run }
on *:keydown:@Tetris:*: {
  var %Piece = $hget(Tetris,Piece) , %Dir = $hget(Tetris,Dir) , %CX = $hget(Tetris,CX) , %CY = $hget(Tetris,CY) , %x = $hget(Tetris,x) , %y = $hget(Tetris,y)
  var %Next = $hget(Tetris,Next) , %NextDir = $hget(Tetris,NextDir) , %Hold = $hget(Tetris,Hold) , %HoldDir = $hget(Tetris,HoldDir)
  ;echo -s $keyval
  if (!$hget(Tetris,Over)) {
    if (%x > 0) && ($keyval = 32) { ;space
      if ($hget(Tetris,Pause)) { hinc Tetris Time $calc($ctime - $v1) | hdel -w Tetris Pause | titlebar @Tetris }
      else { 
        hadd -m Tetris Pause $ctime 
        titlebar @Tetris Paused... 
        drawcopy -t @Tetris.Blocks 0 140 0 140 40 @Tetris $calc(1.5 *20) $calc(8 *20)
      }
    }
    if (!$hget(Tetris,Pause)) {
      if (%x > 0) && ($keyval = 37) { ;left
        dec %x
        if (!$Tetris.Collisiontest(%Piece,%Dir,%x,%y)) {
          hadd -m Tetris x %x
          hadd -m Tetris CX %x
          if ($Tetris.Collisiontest(%Piece,%Dir,%x) != %CY) { hadd -m Tetris CY $v1 }
          tetris 1
        }
      }
      if ($keyval = 38) { ;up
        inc %Dir
        if (%Dir > 4) %Dir = 1
        if (!$Tetris.Collisiontest(%Piece,%Dir,%x,%y)) {
          hadd -m Tetris Dir %Dir
          hadd -m Tetris CY $Tetris.Collisiontest(%Piece,%Dir,%x)
          tetris 1 
        }
      }
      if ($keyval = 39) { ;right
        inc %x
        if (!$Tetris.Collisiontest(%Piece,%Dir,%x,%y)) {
          hadd -m Tetris x %x
          hadd -m Tetris CX %x
          if ($Tetris.Collisiontest(%Piece,%Dir,%x) != %CY) { hadd -m Tetris CY $v1 }
          tetris 1
        }
      }
      if ($keyval = 40) { ;down
        tetris.heartbeat
      }
      if ($keyval = 34) { ;pgdn
        hadd -m Tetris Y $Tetris.Collisiontest(%Piece,%Dir,%x)
        tetris.heartbeat
      }
      if ($keyval = 16) { ;shift (hold)
        if (%Hold = $null) {
          if (!$Tetris.Collisiontest(%Next,%NextDir,%x,%y)) {
            hadd -m Tetris Hold %Piece
            hadd -m Tetris HoldDir %Dir
            hadd -m Tetris Piece %Next
            hadd -m Tetris Dir %NextDir
            hadd -m Tetris Next $r(0,6)
            hadd -m Tetris NextDir $r(1,4)
            hadd -m Tetris CY $Tetris.Collisiontest(%Next,%NextDir,%x)
            tetris 1 
          }        
        }
        else {
          if (!$Tetris.Collisiontest(%Hold,%HoldDir,%x,%y)) {
            hadd -m Tetris Hold %Piece
            hadd -m Tetris HoldDir %Dir
            hadd -m Tetris Piece %Hold
            hadd -m Tetris Dir %HoldDir
            hadd -m Tetris CY $Tetris.Collisiontest(%Hold,%HoldDir,%x)
            tetris 1 
          }
        }
      }
    }
  }
}
on *:close:@Tetris: { Tetris.Terminate }
